module ApplicationHelper
  def body_data_attributes
    attributes = {}
    if user_signed_in?
      attributes[:loggedin_uid] = current_user.id

      # Legacy attribute for backward compatibility
      attributes[:is_shiftcoordinator] = 1 if current_user.shiftcoordinator?

      # Add role-based data attributes
      current_user.roles.each do |role|
        attributes[:"has_role_#{role.name}"] = 1
      end

      # Add permission-based data attributes
      current_user.roles.each do |role|
        role.permissions.each do |permission|
          attributes[:"can_#{permission.name}"] = 1
        end
      end

      attributes[:languages_from] = current_user.languages_from unless current_user.languages_from.blank?
    end

    attributes[:darkmode] = current_user&.darkmode || "auto"
    { data: attributes }
  end
end
